import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoodsSpecRel, ThinkGoodsSpecRelParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询商品与规格值关系记录表
 */
export async function pageThinkGoodsSpecRel(params: ThinkGoodsSpecRelParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoodsSpecRel>>>(
    THINK_API_URL + '/think/think-goods-spec-rel/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品与规格值关系记录表列表
 */
export async function listThinkGoodsSpecRel(params?: ThinkGoodsSpecRelParam) {
  const res = await request.get<ApiResult<ThinkGoodsSpecRel[]>>(
    THINK_API_URL + '/think/think-goods-spec-rel',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品与规格值关系记录表
 */
export async function addThinkGoodsSpecRel(data: ThinkGoodsSpecRel) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-spec-rel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品与规格值关系记录表
 */
export async function updateThinkGoodsSpecRel(data: ThinkGoodsSpecRel) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-spec-rel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品与规格值关系记录表
 */
export async function removeThinkGoodsSpecRel(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-spec-rel/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品与规格值关系记录表
 */
export async function removeBatchThinkGoodsSpecRel(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-spec-rel/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品与规格值关系记录表
 */
export async function getThinkGoodsSpecRel(id: number) {
  const res = await request.get<ApiResult<ThinkGoodsSpecRel>>(
    THINK_API_URL + '/think/think-goods-spec-rel/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
